[type/__package_pkg_openbsd] Clean up code

This commit is contained in:
Takashi Yoshi 2018-12-14 12:35:04 +01:00
parent 498628d16a
commit aa456ab6c1
1 changed files with 74 additions and 76 deletions

View File

@ -23,100 +23,98 @@
# Manage packages with pkg on OpenBSD
#
# Debug
# exec >&2
# set -x
os_version=$(cat "${__global}/explorer/os_version")
machine=$(cat "${__global}/explorer/machine")
os_version="$(cat "$__global/explorer/os_version")"
machine="$(cat "$__global/explorer/machine")"
if [ -f "$__object/parameter/version" ]; then
version="$(cat "$__object/parameter/version")"
if [ -f "${__object}/parameter/version" ]; then
version=$(cat "${__object}/parameter/version")
fi
if [ -f "$__object/parameter/flavor" ]; then
flavor="$(cat "$__object/parameter/flavor")"
if [ -f "${__object}/parameter/flavor" ]; then
flavor=$(cat "${__object}/parameter/flavor")
fi
# do not show progress bar
pkgopts="-x"
# Do not show progress bar
pkgopts='-x'
if [ -f "$__object/parameter/name" ]; then
name=$(cat "$__object/parameter/name")
name="${__object_id}"
if [ -f "${__object}/parameter/name" ]; then
name=$(cat "${__object}/parameter/name")
fi
if [ -n "${version}" ] && [ -n "${flavor}" ]; then
pkgid="${name}-${version}-${flavor}"
elif [ -n "${version}" ]; then
pkgid="${name}-${version}"
elif [ -f "${__object}/parameter/flavor" ]; then
pkgid="${name}--${flavor}"
else
name="$__object_id"
pkgid="${name}"
fi
if [ -n "$version" ] && [ -n "$flavor" ]; then
pkgid="$name-$version-$flavor"
elif [ -n "$version" ]; then
pkgid="$name-$version"
elif [ -n "$flavor" ]; then
pkgid="$name--$flavor"
elif [ -f "$__object/parameter/flavor" ]; then
pkgid="$name--"
state_should=$(cat "${__object}/parameter/state")
pkg_version=$(cat "${__object}/explorer/pkg_version")
if [ -f "${__object}/parameter/pkg_path" ]; then
pkg_path=$(cat "${__object}/parameter/pkg_path")
else
pkgid="$name"
has_installurl=$(cat "${__object}/explorer/has_installurl")
if [ 'yes' != "${has_installurl}" ]; then
# There is no default PKG_PATH, try to provide one
pkg_path="ftp://ftp.openbsd.org/pub/OpenBSD/${os_version}/packages/${machine}/"
fi
fi
state_should="$(cat "$__object/parameter/state")"
state_is=$(cat "${__object}/explorer/pkg_state")
[ "${state_is}" = "${state_should}" ] && exit 0
pkg_version="$(cat "$__object/explorer/pkg_version")"
case "${state_should}" in
present)
if [ -n "${pkg_path}" ]; then
echo "export PKG_PATH='${pkg_path}'"
fi
if [ -f "$__object/parameter/pkg_path" ]; then
pkg_path="$(cat "$__object/parameter/pkg_path")"
else
has_installurl=$(cat "${__object}/explorer/has_installurl")
if [ Xyes != X"${has_installurl}" ]; then
# there is no default PKG_PATH, try to provide one
pkg_path="ftp://ftp.openbsd.org/pub/OpenBSD/$os_version/packages/$machine/"
fi
fi
# Use this because pkg_add doesn't properly handle errors
cat << EOF
status=\$(pkg_add ${pkgopts} '${pkgid}' 2>&1 || true)
state_is="$(cat "$__object/explorer/pkg_state")"
[ "$state_is" = "$state_should" ] && exit 0
if ! pkg_info -q -I 'inst:${pkgid}' | grep -q '^${name}-${version}.*${flavor}$' 2>/dev/null
then
# We didn't find the package in the list of 'installed packages', so it failed.
# This is necessary because pkg_add doesn't return properly
case "$state_should" in
present)
# use this because pkg_add doesn't properly handle errors
cat << eof
if [ X != X"${pkg_path}" ]; then
PKG_PATH="${pkg_path}"; export PKG_PATH
if [ -z "\${status}" ]; then
status='Failed to add package, uncaught exception.'
fi
echo "Error: \${status}" >&2
exit 1
fi
status=\$(pkg_add "$pkgopts" "$pkgid" 2>&1)
pkg_info -q -I "inst:$pkgid" | grep -q "^${name}-${version}.*${flavor}$" 2>/dev/null
EOF
echo 'installed' >> "${__messages_out}"
;;
# We didn't find the package in the list of 'installed packages', so it failed
# This is necessary because pkg_add doesn't return properly
if [ \$? -ne 0 ]; then
if [ -z "\${status}" ]; then
status="Failed to add package, uncaught exception."
fi
echo "Error: \$status" >&2
exit 1
absent)
# Use this because pkg_delete doesn't properly handle errors
cat << EOF
status=\$(pkg_delete ${pkgopts} '${pkgid}' || true)
if pkg_info -q -I 'inst:${pkgid}' | grep -q '^${name}-${version}.*${flavor}' 2>/dev/null
then
# We found the package in the list of 'installed packages'.
# This would indicate that pkg_delete failed, send the output of pkg_delete
if [ -z "\${status}" ]; then
status='Failed to remove package, uncaught exception.'
fi
echo "Error: \${status}" >&2
exit 1
fi
eof
;;
absent)
# use this because pkg_add doesn't properly handle errors
cat << eof
status=\$(pkg_delete "$pkgopts" "$pkgid")
pkg_info -q -I "inst:$pkgid" | grep -q "^${name}-${version}.*${flavor}" 2>/dev/null
# We found the package in the list of 'installed packages'
# This would indicate that pkg_delete failed, send the output of pkg_delete
if [ \$? -eq 0 ]; then
if [ -z "\${status}" ]; then
status="Failed to remove package, uncaught exception."
fi
echo "Error: \$status" >&2
exit 1
fi
eof
;;
*)
echo "Unknown state: $state_should" >&2
EOF
echo 'removed' >> "${__messages_out}"
;;
*)
echo "Unknown state: ${state_should}" >&2
exit 1
;;
;;
esac